// richedit_cpp_test.cpp : Defines the entry point for the application.
//
// Autor: KoSiarz

#include "stdafx.h"
#include "richedit_cpp_test.h"
#include <string>
#include <vector>

using namespace std;

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_RICHEDIT_CPP_TEST, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_RICHEDIT_CPP_TEST);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_RICHEDIT_CPP_TEST);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_RICHEDIT_CPP_TEST;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}

int DoLiczby (string napis)
{
	int liczba = 0;

	for (size_t i = 0; i < napis.length(); ++i)
	{
		if (napis[i] < '0' || napis[i] > '9') break;
		liczba *= 10;
		liczba += napis[i] - '0';
	}

	return 0;
}

string Konwertuj (const string &tekstRTF)
{
	if ( tekstRTF.empty() )
	{
		return "<html>\n<head>\n</head>\n<body>\n</body>\n</html>";
	}

	size_t i;
	size_t dlugosc = tekstRTF.find_last_of('}');
	string html;							//wynikowy ciag html
	//string tekst = tekstRTF;				//kopia tresci rtf (nie jest konieczna bo i tak jej nie modyfikujemy)
	string fraza;
	bool span = false;						//wskazuje czy wczytano nowy span
	bool span_open = false;					//wskazuje czy jest otwarty jakis span

	std::vector<string> czcionki;			//tablica dostepnych krojow czcionek
	std::vector<string> kolory;				//tablica dostepnych kolorow czcionek
	kolory.push_back ("rgb(0,0,0) ");		//domyslny kolor

	size_t index1;
	size_t index2;
	size_t tmp_index1;
	size_t tmp_index2;

	bool bold = false;		//czy aktualna czcionka ma bolda
	bool italic = false;	//czy aktualna czcionka ma italic
	bool underline = false;	//czy aktualna czcionka ma podkreslenie
	int size = 0;			//wysokosc aktalnej czcionki
	int nrCzcionki = 0;		//nr aktualnego koloru czcionki w tablicy
	int nrKoloru = 0;		//nr aktualnego kroju czcionki w tablicy

	index1 = tekstRTF.find_first_of(' ') + 1;			//pierwsza spacja jest zawsze przed nazwa domyslnej czcionki
	index2 = tekstRTF.find_first_of(";}", index1);		//nazwa domyslnej czionki konczy sie ";}"

	czcionki.push_back( "'" + tekstRTF.substr(index1, index2-index1) + "'"); //wczytanie domyslnej czcionki
	html = "<html>\n<head>\n</head>\n<body>\n<span style=\"font-family: "+ czcionki[0] +", sans-serif;\">\n";

	//wczytanie tablicy wszystkich dostepnych krojow czcionek
	tmp_index2 = tekstRTF.find_first_of(";}}", index1);
	if ( tmp_index2 != index2)
	{
		do
		{
			index1 = tekstRTF.find_first_of("{\\f", index2);
			if ( index1 == -1 || index1 > tmp_index2 ) break;
			index1 = tekstRTF.find_first_of(" ", index1);
			index2 = tekstRTF.find_first_of(";}", index1);
			czcionki.push_back("'" + tekstRTF.substr(index1, index2 - index1) + "'");	
		} 
		while (index2 != tmp_index2);
	}

	//wczytanie tablicy dostepnych kolorow czcionek
	index1 = tekstRTF.find_first_of("{\\colortbl", index2);
	if ( index1 != -1 )
	{
		index1 += 11;
		index2 = tekstRTF.find_first_of(";}", index1);
		for (i = index1; i < index2; i++)
		{
			tmp_index1 = tekstRTF.find_first_of("\\red", i) + 4;
			tmp_index2 = tekstRTF.find_first_of("\\green", tmp_index1);
			fraza = "rgb(" + tekstRTF.substr(tmp_index1, tmp_index2 - tmp_index1) + ",";

			tmp_index1 = tmp_index2 + 6;
			tmp_index2 = tekstRTF.find_first_of("\\blue", tmp_index1);
			fraza += tekstRTF.substr(tmp_index1, tmp_index2 - tmp_index1) + ",";

			tmp_index1 = tmp_index2 + 5;
			tmp_index2 = tekstRTF.find_first_of(";\\red", tmp_index1);
			if ( tmp_index2 == -1 ) tmp_index2 = tekstRTF.find_first_of(";}", tmp_index1);
			fraza += tekstRTF.substr(tmp_index1, tmp_index2 - tmp_index1) + ") ";

			kolory.push_back(fraza);
			i = tmp_index2;
		}
	}

	index1 = tekstRTF.find_first_of("\\pard") + 5;		//od tego zaczyna sie wiadomosc
	index2 = tekstRTF.find_first_of("\\par", index1);	//linia zawsze konczy sie tym znakiem

	//analizujemy cala wiadomosc, 'i' oznacza aktualnie analizowana litere w tekscie
	for (i = index1; i < dlugosc; i++)
	{
		if (tekstRTF[i] == '\\' && tekstRTF[i + 1] != '\\')	//jesli w tekscie jest pojedynczy znak '\' to oznacza ze dalszy tekst tyczy sie formatowania tekstu
		{	//wczytujemy formatowanie

			index1 = i;

			//index2 okresli nam kiedy konczy sie wiadomosc o formatowaniu
			tmp_index2 = index2;
			//index2 = tekstRTF.IndexOf(' ', index1, tmp_index2 - i);				//wtedy gdy za foramtowaniem jest tekst
			index2 = tekstRTF.find_first_of(' ', index1);				//wtedy gdy za foramtowaniem jest tekst
			if ( index2 == string.npos || index2 > tmp_index2 - 1 ) 
			{
				index2 = tekstRTF.find_first_of("\\\\", index1);	//wtedy gdy za formatowaniem jest tekst ropoczynajacy sie znakiem '\'
				if ( index2 < string.npos ) index2 = tekstRTF.find_first_of("\\par", index1);		//za formatowaniem juz nic nie ma, jest tylko przejscie do nowej lini
				else index2 -= 1;
			}

			tmp_index1 = tmp_index2 = 0;

			//analizu tekstu formatujacego
			for (i = index1; i <= index2 ; i++)
			{

				if (tekstRTF[i] == '\\' || i == index2) //jesli jest spelniony oznacza ze bedzie nowy argument formatowania, wiec zapamietujemy wkaznik na poczatek argumentu
				{
					if (tmp_index1 == 0) { tmp_index1 = i + 1; ++i; }
					else 
					{
						if (tmp_index2 == 0) tmp_index2 = i;
						fraza = tekstRTF.substr(tmp_index1, tmp_index2 - tmp_index1);

						//sprawdzamy wszystkie argumenty formatujace
						if (fraza == "ul")
						{
							underline = true;
						}
						else if (fraza == "ulnone")
						{
							underline = false;
						}
						else if (fraza == "b")
						{
							if (tmp_index2 == i) bold = true;
							else bold = false;
						}
						else if (fraza == "i")
						{
							if (tmp_index2 == i) italic = true;
							else italic = false;
						}
						else if (fraza == "f")
						{
							nrCzcionki = DoLiczby( tekstRTF.substr(tmp_index2, i - tmp_index2) );
						}
						else if (fraza == "fs")
						{
							size = DoLiczby( tekstRTF.substr(tmp_index2, i - tmp_index2) );
						}
						else if (fraza == "cf")
						{
							nrKoloru = DoLiczby( tekstRTF.substr(tmp_index2, i - tmp_index2) );
						}

						tmp_index2 = 0;
						tmp_index1 = i+1;
						++i;
					}
				}
				else if (tekstRTF[i] >= '0' && tekstRTF[i] <= '9')	//jesli prawda to znaczy ze argument ma jakis parametr, wiec zachowujemy skaznik na niego
				{
					if (tmp_index2 == 0) tmp_index2 = i;
				}
				
			}

			if ( span ) { html += "</span>\n"; span_open = false; } //bardzo mozliwe ze ta linijka jest niepotrzebna

			i = index2;
			index2 = tekstRTF.find_first_of("\\par", index1);
			span = true;	//oznaczamy ze wystapila zmiana sposobu formatowania
			if ( i != index2 ) continue;
		}

		//ta czesc analizuje nam tresc (nie formatowanie ktore bylo analizowane wyzej)
		index1 = i;		//zapamietujemy wskaznik na poczatek napisu
		for (i = i; i <= index2; i++)	//szukamy konca napisu
		{
			if ( tekstRTF[i] == '\\' )
			{
				if ( tekstRTF[i + 1] != '\\' ) break;		//koniec napisu jest wtedy gdy wystapi znak '\' ale nie gdy wystapia dwa po sobie '\\'
				else ++i;
			}
		}				

		if ( span ) //jesli zmienilo sie formatowanie to trzeba je zapisac przed podaniem tekstu
		{
			if ( span_open ) fraza = "</span>\n<span style=\"font: "; //jesli bylo otwarte jakies formatowanie to nalezy je zamknac
			else fraza = "<span style=\"font: ";

			if ( italic ) fraza += " italic ";
			if ( bold ) fraza += " bold ";
			if ( !italic && !bold ) fraza += " normal ";
			fraza += " ";
			fraza += size + "px ";
			fraza += " ";
			fraza += czcionki[nrCzcionki] + "; ";

			if ( underline ) fraza += " text-decoration: underline; ";
			else fraza += " text-decoration: none; ";

			fraza += " color: " + kolory[nrKoloru] + ";\">";

			html += fraza;
			span = false;
			span_open = true;
		}

		fraza = tekstRTF.substr(index1, i - index1);
		size_t tmp_dlugosc = fraza.length() - 1;
		for (size_t j = 0; j < tmp_dlugosc; ++j)
		{
			if (fraza[j] == '\\' && fraza[j] == '\\')
			{
				fraza.erase(j, 1);
				--tmp_dlugosc;
			}
		}
		//fraza.replace("\\\\","\\");
		html += fraza;	//zapisujemy tekst do htmla jednoczesnie zamieniejac wszystkie '\\' na '\'

		if ( i != index2 ) //jesli spelnoine to nie dotarlismy jeszce do konca linijki wiec zaczynaja sie nowe argumenty formatowania
		{ 
			html += "</span>\n"; 
			span_open = false; 
			--i; 
			continue; 
		}
		else
		{
			if (dlugosc - index2 > 7) //jesli spelnione to jeszcze nie jest koniec calej wiadomosci
			{
				html += "<br />\n\n";
				i = index2 + 5;
				index2 = tekstRTF.find_first_of("\\par", i + 1);						
			}
			else break;
		}
	}

	if ( span_open ) html += "</span>";
	html += "\n</span>\n</body>\n</html>";

	return html;
}
